function out = cij_gen_2019(n,nP,Np)



cij_matrix=zeros(n,n); %Create an nxn cell. 
%If nP(i)>=1, then the number of elements within this cell corresponds to the number of neighbors each agent has.

for i =1:n %% LOOP 1. Agent i.
    
       if nP(i)==0
         cij_matrix(i,:)=zeros(1,n); %If i has no neighbors, then we can set row i of the ci matrix to be a 1xn vector of zeros
       else           

           
        %We only need to look at the union of the neighborhoods of i's
        %neighbors. 
            neighbors_of_is_neighbors=cell(nP(i),1);
            for k_=1:nP(i)
                k=Np{i}(k_);
                neighbors_of_is_neighbors{k_}=Np{k};
            end
            
            js=unique([neighbors_of_is_neighbors{:}]); %These are the j's that are conceivably relevant. 
            njs=size(js,2); %Note that the cell stores ROW vectors, so the relevant dimension is the second dimension
            
            
            for j_=1:njs %Check each relevant j
                j=js(j_); %Extract the relevant index
                ctemp2=zeros(nP(i),1);
                for k_=1:nP(i) %Loop over i's Gp neighbors
                    k=Np{i}(k_); %find the actual index of the neighbor
                    Npk=Np{k}; %Find the Gp neighbors of k
                    ctemp2(k_)=any(j==Npk);
                end
                cij_matrix(i,j)=sum(ctemp2)/nP(i);
            end      
       end       
end


%Given sample size, n, number of neighbors, nP, and list of neighbors, Np,
%compute cii's and cij's for each i.
% ci_vector=zeros(n,1);

% % ci_vector2=zeros(n,1);
% for i=1:n
%     if nP(i)==0;        %If the neighborhood is empty
%         ci_vector(i)=0; %Assign zero to cii
%     else        
%         ctemp=zeros(nP(i),1); %Make a vector the length of length nP(i)
%     for k_=1:nP(i)
%         k=Np{i}(k_); %Extract the payoff neighbor of i, called k
%         ctemp(k_)=any(i==Np{k})/(nP(k)+1); %Check if i lies k's Gp neighborhood. Record 1 if yes. 
%         if nP(k)==0
%             ctemp(k_)=0;
%         end
%     end
%         ci_vector(i)=sum(ctemp)/nP(i);    
%     end
% end



out=cij_matrix;
    
end




            
            
            
            
        