% Generate Graphs for Generating True Parameters along Barabasi-Albert.

clear
rng('default');
lam=1;         % parameter for Erdos-Renyi network used as a seed.
S=20;          % The number of the nodes in the seed network.

in=[300 600];    % The number of the nodes in the graph
sn=size(in,2); 
         
for nindex=1:sn
    
    n=in(nindex); % The number of the nodes in the network.
    tag=0;p=lam/(S-1);itr=0;
    while tag==0&&itr<200;
          itr=itr+1;
          seed=erdos_renyi(S,p); % Construct a Erdos-Renyu graph of size S.
  
          if size((seed>0),1)>0; % Check whether the graph is empty or not.
             tag=1;
          end
    end
            
    seed=seed-diag(diag(seed)); % The diagonal terms are set to be zero.
    
    for mks=1:3;
        graph=barabasi_albert(n,mks,seed); % Generate a graph from Barabasi-Albert
                                             % the graph is in the form of an adjacency matrix.     
        graph=graph-diag(diag(graph));        % Diagonal terms are set to be zero                                     
        if mks==1;
           if n==300;
               graph_ba_1_300=graph;
           elseif n==600;
               graph_ba_1_600=graph;
           end
        elseif mks==2;
           if n==300;
               graph_ba_2_300=graph;
           elseif n==600;
               graph_ba_2_600=graph;
           end
        elseif mks==3;
           if n==300;
               graph_ba_3_300=graph;
           elseif n==600;
               graph_ba_3_600=graph;
           end
        end
        
    end
end

save('main_ba_graph')

 