    
function graphdata=graph_generate_fos(lam,n,gtype);


if gtype==1
    Gp=full(erdos_renyi(n,lam/n));
    
else if gtype==0
        m0=lam;
        Gp=double(main_ba_graph(m0,n));
    end
end

Gpb=Gp;
Gp2b=(Gp+Gp*Gp)>0;
Gp4b=(Gp+Gp^2+Gp^3+Gp^4)>0;
Gp2=Gp2b;
Gp4=Gp4b;

for i =1:n
    Gpb(i,i)=1;  %Used in W_gen.m
    Gp2b(i,i)=1; %Used in W_gen.m
    Gp2(i,i)=0;
    Gp4(i,i)=0;
end


Np=cell(n,1);
nP=zeros(n,1);

Npb=cell(n,1);
nPb=zeros(n,1);

Np2=cell(n,1); 
nP2=zeros(n,1); 

Np4=cell(n,1);
nP4=zeros(n,1);

parfor j =1:n
    Np{j}=find(Gp(j,:));
    nP(j)=size(Np{j},2); 
    
    Npb{j}=find(Gpb(j,:));
    nPb(j)=size(Npb{j},2);
    
    Np2{j}=find(Gp2(j,:)); %Used in qirowgen_fos.m, inters.m, lambda_gen_inst.m
    nP2(j)=size(Np2{j},2); %Used in qirowgen_fos.m, inters.m, lambda_gen_inst.m
    
    Np4{j}=find(Gp4(j,:)); %Used in qirowgen_fos.m
    nP4(j)=size(Np4{j},2); %Used in qirowgen_fos.m
end


%Following is used to construct lambda_2_hat_FS in stats_asymptotic_fos.m

Gp4_tilde=zeros(n,n);
Np4_tilde=cell(n,1);

parfor i =1:n       
    Gp4_tilde(i,:)= inters(n,Np2,i);   %Used in stats_asymptotic_fos.m 
    Np4_tilde{i}=find(Gp4_tilde(i,:)); %Used in stats_asymptotic_fos.m
end

nP4_tilde=sum(Gp4_tilde,2);


graphdata={Gp,Np,nP,Gpb,Npb,nPb,Gp2,Np2,nP2,Np4_tilde,nP4_tilde,Np4,nP4,Gp2b};
end