function out = cij_gen_2019(n,nP,Np)


zer_1_by_n=zeros(1,n);



cij_matrix=zeros(n,n); %Create an nxn cell.


for i =1:n %% LOOP 1. Agent i.
    
    if nP(i)==0
        cij_matrix(i,:)=zer_1_by_n; %If i has no neighbors, then we can set row i of the ci matrix to be a 1xn vector of zeros
    else
        
        
        %We only need to look at the union of the neighborhoods of i's
        %neighbors.
        
        neighbors_of_is_neighbors=cell(nP(i),1);
        for k_=1:nP(i)
            k=Np{i}(k_);
            neighbors_of_is_neighbors{k_}=Np{k};
        end
        
        js=unique([neighbors_of_is_neighbors{:}]); %These are the j's that are conceivably relevant.
        js_li=setdiff(js,i);  %Remove i
        njs=size(js_li,2); %Note that the cell stores ROW vectors, so the relevant dimension is the second dimension
        
        
        for j_=1:njs %Check each relevant j
            j=js_li(j_); %Extract the relevant index
            ctemp2=zeros(nP(i),1);
            for k_=1:nP(i) %Loop over i's Gp neighbors
                k=Np{i}(k_); %find the actual index of the neighbor
                Npk=Np{k}; %Find the Gp neighbors of k
                ctemp2(k_)=any(j==Npk);
            end
            cij_matrix(i,j)=sum(ctemp2)/nP(i);
        end
    end
end


out=cij_matrix;





end


